#!/bin/bash

ulimit -n 16384

cd $(dirname $0)

for i in "$@"
do
case $i in
    --accessibility=*)
    if [[ ${i#*=} = true ]]; then
        export QT_LINUX_ACCESSIBILITY_ALWAYS_ON=1
    fi
    ;;

    --linuxfb=*)
    if [[ ${i#*=} = true ]]; then
        export QT_QPA_PLATFORM=linuxfb:fb=/dev/fb0
    fi
    ;;
esac
done

for PID in $(pidof BCSService); do
    kill  $PID
done

cd bin

export LD_LIBRARY_PATH=../lib:../lib/dahua:../lib/ffmpeg:../lib/hikvision:../lib/qt
./BCSService -exec &
./cms &

# Podczas restartu aplikacji uruchamiana jest nowa detached instancja.
# Dlatego skrypt musi sprawdzać, czy działa jakikolwiek proces o nazwie cms.
while p=$(pidof cms); do
    sleep 1
done

echo "BCS Manager has finished. Bye."
