#!/bin/bash

INSTALL_DIR=/opt/bcsm

export NEWT_COLORS='root=,blue'

while
    while
        mode=$(whiptail \
            --title "BCS Manager" \
            --nocancel \
            --menu "Proszę wybrać tryb instalacji." 11 50 3 \
                "standalone" "Zwykła instalacja" \
                "client" "Instalacja klienta ustawień" \
                "server" "Instalacja serwera ustawień" \
            3>&1 1>&2 2>&3)
    [ $? != 0 ]
    do :; done

    case $mode in
        standalone)
            echo "Zwykła instalacja..."
            ln -srf $INSTALL_DIR/lib/libSettingsFormatIni/libSettingsFormat.so* $INSTALL_DIR/lib
            ln -srf $INSTALL_DIR/bin/service/BCSService $INSTALL_DIR/bin
        ;;

        client)
            ADDRESS=$(whiptail \
                --title "BCS Manager - Instalacja klienta ustawień" \
                --inputbox "Podaj adres serwera w formacie <ip:port>:" 8 50 "127.0.0.1:27182" \
                3>&1 1>&2 2>&3)
            if [[ $? != 0 ]]; then
                continue
            fi
            echo "Instalacja klienta ustawień..."
            IFS=: read HOST PORT <<< $ADDRESS
            ln -srf $INSTALL_DIR/lib/libSettingsFormatBcs/libSettingsFormat.so* $INSTALL_DIR/lib
            ln -srf $INSTALL_DIR/bin/service/BCSService $INSTALL_DIR/bin
        ;;

        server)
            HOST=127.0.0.1
            PORT=$(whiptail \
                --title "BCS Manager - Instalacja serwera ustawień" \
                --inputbox "Podaj port, na którym będzie działał serwer" 8 50 "27182" \
                3>&1 1>&2 2>&3)
            if [[ $? != 0 ]]; then
                continue
            fi
            echo "Instalacja serwera ustawień..."
            ln -srf $INSTALL_DIR/lib/libSettingsFormatBcs/libSettingsFormat.so* $INSTALL_DIR/lib
            ln -srf $INSTALL_DIR/bin/service_ssvr/BCSService $INSTALL_DIR/bin
        ;;

        *)
            echo "$HELP"
            exit 1
        ;;
    esac
false
do :; done

if [[ $mode = @(client|server) ]]; then
    CONF_DIR=/etc/xdg/BCSManager
    mkdir -p ${CONF_DIR}

    echo "[SettingsServer]
settingsServerHost=${HOST}
settingsServerPort=${PORT}" > ${CONF_DIR}/SettingsServer.ini
fi

exit 0

echo "Instalacja i uruchomienie usługi BCSService..."
chmod o-x $INSTALL_DIR/bin/BCSService
mkdir -p /root/.config/BCSManager
systemctl daemon-reload
systemctl stop BCSService
systemctl enable BCSService
systemctl start BCSService
systemctl status BCSService
